diff --git a/libavcodec/4xm.c b/libavcodec/4xm.c
index 5636fdef2d..a26b2f9004 100644
--- a/libavcodec/4xm.c
+++ b/libavcodec/4xm.c
@@ -469,8 +469,8 @@ static int decode_p_frame(FourXContext *f, const uint8_t *buf, int length)
                           bitstream_size);
     if (!f->bitstream_buffer)
         return AVERROR(ENOMEM);
-    f->bbdsp.bswap_buf(f->bitstream_buffer, (const uint32_t *) (buf + extra),
-                       bitstream_size / 4);
+    f->bbdsp.bswap32_buf(f->bitstream_buffer, (const uint32_t *) (buf + extra),
+                         bitstream_size / 4);
     init_get_bits(&f->gb, f->bitstream_buffer, 8 * bitstream_size);
 
     wordstream_offset = extra + bitstream_size;
@@ -813,8 +813,8 @@ static int decode_i_frame(FourXContext *f, const uint8_t *buf, int length)
                           prestream_size);
     if (!f->bitstream_buffer)
         return AVERROR(ENOMEM);
-    f->bbdsp.bswap_buf(f->bitstream_buffer, (const uint32_t *) prestream,
-                       prestream_size / 4);
+    f->bbdsp.bswap32_buf(f->bitstream_buffer, (const uint32_t *) prestream,
+                         prestream_size / 4);
     init_get_bits(&f->pre_gb, f->bitstream_buffer, 8 * prestream_size);
 
     f->last_dc = 0 * 128 * 8 * 8;
diff --git a/libavcodec/alsdec.c b/libavcodec/alsdec.c
index 4605b2248f..6f401cf890 100644
--- a/libavcodec/alsdec.c
+++ b/libavcodec/alsdec.c
@@ -1899,9 +1899,9 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *frame,
                          sample++)
                         *dest++ = av_bswap16(src[sample]);
                 } else {
-                    ctx->bdsp.bswap_buf((uint32_t *) ctx->crc_buffer,
-                                        (uint32_t *) frame->data[0],
-                                        ctx->cur_frame_length * channels);
+                    ctx->bdsp.bswap32_buf((uint32_t *) ctx->crc_buffer,
+                                          (uint32_t *) frame->data[0],
+                                          ctx->cur_frame_length * channels);
                 }
                 crc_source = ctx->crc_buffer;
             } else {
diff --git a/libavcodec/apedec.c b/libavcodec/apedec.c
index c08d13d6c2..b7856c82e5 100644
--- a/libavcodec/apedec.c
+++ b/libavcodec/apedec.c
@@ -1499,8 +1499,8 @@ static int ape_decode_frame(AVCodecContext *avctx, AVFrame *frame,
         av_fast_padded_malloc(&s->data, &s->data_size, buf_size);
         if (!s->data)
             return AVERROR(ENOMEM);
-        s->bdsp.bswap_buf((uint32_t *) s->data, (const uint32_t *) buf,
-                          buf_size >> 2);
+        s->bdsp.bswap32_buf((uint32_t *) s->data, (const uint32_t *) buf,
+                            buf_size >> 2);
         memset(s->data + (buf_size & ~3), 0, buf_size & 3);
         s->ptr = s->data;
         s->data_end = s->data + buf_size;
diff --git a/libavcodec/asvdec.c b/libavcodec/asvdec.c
index 699aab9f8f..25dab7473f 100644
--- a/libavcodec/asvdec.c
+++ b/libavcodec/asvdec.c
@@ -253,8 +253,8 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *p,
         if (!a->bitstream_buffer)
             return AVERROR(ENOMEM);
 
-        c->bbdsp.bswap_buf((uint32_t *) a->bitstream_buffer,
-                           (const uint32_t *) buf, buf_size / 4);
+        c->bbdsp.bswap32_buf((uint32_t *) a->bitstream_buffer,
+                             (const uint32_t *) buf, buf_size / 4);
         ret = init_get_bits8(&a->gb, a->bitstream_buffer, buf_size);
     } else {
         ret = init_get_bits8_le(&a->gb, buf, buf_size);
diff --git a/libavcodec/asvenc.c b/libavcodec/asvenc.c
index 9da7cbb986..2bf67d686c 100644
--- a/libavcodec/asvenc.c
+++ b/libavcodec/asvenc.c
@@ -309,8 +309,8 @@ static int encode_frame(AVCodecContext *avctx, AVPacket *pkt,
     size = (put_bytes_output(&a->pb) + 3) / 4;
 
     if (avctx->codec_id == AV_CODEC_ID_ASV1) {
-        c->bbdsp.bswap_buf((uint32_t *) pkt->data,
-                           (uint32_t *) pkt->data, size);
+        c->bbdsp.bswap32_buf((uint32_t *) pkt->data,
+                             (uint32_t *) pkt->data, size);
     }
 
     pkt->size   = size * 4;
diff --git a/libavcodec/bswapdsp.c b/libavcodec/bswapdsp.c
index f0ea2b55c5..432f53efbf 100644
--- a/libavcodec/bswapdsp.c
+++ b/libavcodec/bswapdsp.c
@@ -22,11 +22,11 @@
 #include "libavutil/bswap.h"
 #include "bswapdsp.h"
 
-static void bswap_buf(uint32_t *dst, const uint32_t *src, int w)
+static void bswap32_buf(uint32_t *dst, const uint32_t *src, int len)
 {
     int i;
 
-    for (i = 0; i + 8 <= w; i += 8) {
+    for (i = 0; i + 8 <= len; i += 8) {
         dst[i + 0] = av_bswap32(src[i + 0]);
         dst[i + 1] = av_bswap32(src[i + 1]);
         dst[i + 2] = av_bswap32(src[i + 2]);
@@ -36,7 +36,7 @@ static void bswap_buf(uint32_t *dst, const uint32_t *src, int w)
         dst[i + 6] = av_bswap32(src[i + 6]);
         dst[i + 7] = av_bswap32(src[i + 7]);
     }
-    for (; i < w; i++)
+    for (; i < len; i++)
         dst[i + 0] = av_bswap32(src[i + 0]);
 }
 
@@ -48,7 +48,7 @@ static void bswap16_buf(uint16_t *dst, const uint16_t *src, int len)
 
 av_cold void ff_bswapdsp_init(BswapDSPContext *c)
 {
-    c->bswap_buf   = bswap_buf;
+    c->bswap32_buf = bswap32_buf;
     c->bswap16_buf = bswap16_buf;
 
 #if ARCH_RISCV
diff --git a/libavcodec/bswapdsp.h b/libavcodec/bswapdsp.h
index 6f4db66115..10519cfd2e 100644
--- a/libavcodec/bswapdsp.h
+++ b/libavcodec/bswapdsp.h
@@ -22,7 +22,7 @@
 #include <stdint.h>
 
 typedef struct BswapDSPContext {
-    void (*bswap_buf)(uint32_t *dst, const uint32_t *src, int w);
+    void (*bswap32_buf)(uint32_t *dst, const uint32_t *src, int len);
     void (*bswap16_buf)(uint16_t *dst, const uint16_t *src, int len);
 } BswapDSPContext;
 
diff --git a/libavcodec/eatqi.c b/libavcodec/eatqi.c
index e4f12b3db2..ec4bf02720 100644
--- a/libavcodec/eatqi.c
+++ b/libavcodec/eatqi.c
@@ -148,8 +148,8 @@ static int tqi_decode_frame(AVCodecContext *avctx, AVFrame *frame,
                           buf_end - buf);
     if (!t->bitstream_buf)
         return AVERROR(ENOMEM);
-    t->bsdsp.bswap_buf(t->bitstream_buf, (const uint32_t *) buf,
-                       (buf_end - buf) / 4);
+    t->bsdsp.bswap32_buf(t->bitstream_buf, (const uint32_t *) buf,
+                         (buf_end - buf) / 4);
     init_get_bits(&t->gb, t->bitstream_buf, 8 * (buf_end - buf));
 
     t->last_dc[0] =
diff --git a/libavcodec/fraps.c b/libavcodec/fraps.c
index 4c4c46b602..1a0f52ebe6 100644
--- a/libavcodec/fraps.c
+++ b/libavcodec/fraps.c
@@ -106,8 +106,8 @@ static int fraps2_decode_plane(FrapsContext *s, uint8_t *dst, int stride, int w,
     /* we have built Huffman table and are ready to decode plane */
 
     /* convert bits so they may be used by standard bitreader */
-    s->bdsp.bswap_buf((uint32_t *) s->tmpbuf,
-                      (const uint32_t *) src, size >> 2);
+    s->bdsp.bswap32_buf((uint32_t *) s->tmpbuf,
+                        (const uint32_t *) src, size >> 2);
 
     if ((ret = init_get_bits8(&gb, s->tmpbuf, size)) < 0)
         return ret;
diff --git a/libavcodec/huffyuvdec.c b/libavcodec/huffyuvdec.c
index 7d3515cc88..f5793d2eec 100644
--- a/libavcodec/huffyuvdec.c
+++ b/libavcodec/huffyuvdec.c
@@ -1239,8 +1239,8 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *p,
     if (!s->bitstream_buffer)
         return AVERROR(ENOMEM);
 
-    s->bdsp.bswap_buf((uint32_t *) s->bitstream_buffer,
-                      (const uint32_t *) buf, buf_size / 4);
+    s->bdsp.bswap32_buf((uint32_t *) s->bitstream_buffer,
+                        (const uint32_t *) buf, buf_size / 4);
 
     if ((ret = ff_thread_get_buffer(avctx, p, 0)) < 0)
         return ret;
@@ -1282,8 +1282,8 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *p,
                 return AVERROR_INVALIDDATA;
 
             y_offset = height - (slice + 1) * slice_height;
-            s->bdsp.bswap_buf((uint32_t *)s->bitstream_buffer,
-                              (const uint32_t *)(buf + slice_offset), slice_size / 4);
+            s->bdsp.bswap32_buf((uint32_t *)s->bitstream_buffer,
+                                (const uint32_t *)(buf + slice_offset), slice_size / 4);
         } else {
             y_offset = 0;
             slice_offset = 0;
diff --git a/libavcodec/huffyuvenc.c b/libavcodec/huffyuvenc.c
index db274e37ad..b26f2a8fd6 100644
--- a/libavcodec/huffyuvenc.c
+++ b/libavcodec/huffyuvenc.c
@@ -1018,7 +1018,7 @@ static int encode_frame(AVCodecContext *avctx, AVPacket *pkt,
         avctx->stats_out[0] = '\0';
     if (!(s->avctx->flags2 & AV_CODEC_FLAG2_NO_OUTPUT)) {
         flush_put_bits(&s->pb);
-        s->bdsp.bswap_buf((uint32_t *) pkt->data, (uint32_t *) pkt->data, size);
+        s->bdsp.bswap32_buf((uint32_t *) pkt->data, (uint32_t *) pkt->data, size);
     }
 
     s->picture_number++;
diff --git a/libavcodec/imm4.c b/libavcodec/imm4.c
index ccec5dff43..1372afacfd 100644
--- a/libavcodec/imm4.c
+++ b/libavcodec/imm4.c
@@ -368,9 +368,9 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *frame,
     if (!s->bitstream)
         return AVERROR(ENOMEM);
 
-    s->bdsp.bswap_buf((uint32_t *)s->bitstream,
-                      (uint32_t *)avpkt->data,
-                      (avpkt->size + 3) >> 2);
+    s->bdsp.bswap32_buf((uint32_t *)s->bitstream,
+                        (uint32_t *)avpkt->data,
+                        (avpkt->size + 3) >> 2);
 
     if ((ret = init_get_bits8(gb, s->bitstream, FFALIGN(avpkt->size, 4))) < 0)
         return ret;
diff --git a/libavcodec/mimic.c b/libavcodec/mimic.c
index 891471b30e..6cc46b6c38 100644
--- a/libavcodec/mimic.c
+++ b/libavcodec/mimic.c
@@ -411,9 +411,9 @@ static int mimic_decode_frame(AVCodecContext *avctx, AVFrame *rframe,
     if (!ctx->swap_buf)
         return AVERROR(ENOMEM);
 
-    ctx->bbdsp.bswap_buf(ctx->swap_buf,
-                         (const uint32_t *) (buf + MIMIC_HEADER_SIZE),
-                         swap_buf_size >> 2);
+    ctx->bbdsp.bswap32_buf(ctx->swap_buf,
+                           (const uint32_t *) (buf + MIMIC_HEADER_SIZE),
+                           swap_buf_size >> 2);
     init_get_bits(&ctx->gb, ctx->swap_buf, swap_buf_size << 3);
 
     res = decode(ctx, quality, num_coeffs, !is_pframe);
diff --git a/libavcodec/motionpixels.c b/libavcodec/motionpixels.c
index 4141c5a495..9199c0eaa4 100644
--- a/libavcodec/motionpixels.c
+++ b/libavcodec/motionpixels.c
@@ -294,8 +294,8 @@ static int mp_decode_frame(AVCodecContext *avctx, AVFrame *rframe,
     av_fast_padded_malloc(&mp->bswapbuf, &mp->bswapbuf_size, buf_size);
     if (!mp->bswapbuf)
         return AVERROR(ENOMEM);
-    mp->bdsp.bswap_buf((uint32_t *) mp->bswapbuf, (const uint32_t *) buf,
-                       buf_size / 4);
+    mp->bdsp.bswap32_buf((uint32_t *) mp->bswapbuf, (const uint32_t *) buf,
+                         buf_size / 4);
     if (buf_size & 3)
         memcpy(mp->bswapbuf + (buf_size & ~3), buf + (buf_size & ~3), buf_size & 3);
     init_get_bits(&gb, mp->bswapbuf, buf_size * 8);
diff --git a/libavcodec/mpc7.c b/libavcodec/mpc7.c
index d2745366c2..cb15de88e1 100644
--- a/libavcodec/mpc7.c
+++ b/libavcodec/mpc7.c
@@ -93,7 +93,7 @@ static av_cold int mpc7_decode_init(AVCodecContext * avctx)
     av_lfg_init(&c->rnd, 0xDEADBEEF);
     ff_bswapdsp_init(&c->bdsp);
     ff_mpadsp_init(&c->mpadsp);
-    c->bdsp.bswap_buf((uint32_t *) buf, (const uint32_t *) avctx->extradata, 4);
+    c->bdsp.bswap32_buf((uint32_t *) buf, (const uint32_t *) avctx->extradata, 4);
     init_get_bits(&gb, buf, 128);
 
     c->IS = get_bits1(&gb);
@@ -211,7 +211,7 @@ static int mpc7_decode_frame(AVCodecContext *avctx, AVFrame *frame,
     av_fast_padded_malloc(&c->bits, &c->buf_size, buf_size);
     if (!c->bits)
         return AVERROR(ENOMEM);
-    c->bdsp.bswap_buf((uint32_t *) c->bits, (const uint32_t *) buf,
+    c->bdsp.bswap32_buf((uint32_t *) c->bits, (const uint32_t *) buf,
                       buf_size >> 2);
     if ((ret = init_get_bits8(&gb, c->bits, buf_size)) < 0)
         return ret;
diff --git a/libavcodec/rawdec.c b/libavcodec/rawdec.c
index c20c317fed..e15e72eb14 100644
--- a/libavcodec/rawdec.c
+++ b/libavcodec/rawdec.c
@@ -321,7 +321,7 @@ static int raw_decode(AVCodecContext *avctx, AVFrame *frame,
             if (swap == 16)
                 context->bbdsp.bswap16_buf(context->bitstream_buf, (const uint16_t*)buf, buf_size / 2);
             else if (swap == 32)
-                context->bbdsp.bswap_buf(context->bitstream_buf, (const uint32_t*)buf, buf_size / 4);
+                context->bbdsp.bswap32_buf(context->bitstream_buf, (const uint32_t*)buf, buf_size / 4);
             else
                 return AVERROR_INVALIDDATA;
             buf = context->bitstream_buf;
diff --git a/libavcodec/riscv/bswapdsp_init.c b/libavcodec/riscv/bswapdsp_init.c
index abe84ec1f7..4d229c53e3 100644
--- a/libavcodec/riscv/bswapdsp_init.c
+++ b/libavcodec/riscv/bswapdsp_init.c
@@ -35,11 +35,11 @@ av_cold void ff_bswapdsp_init_riscv(BswapDSPContext *c)
 
 #if (__riscv_xlen >= 64)
     if (cpu_flags & AV_CPU_FLAG_RVB_BASIC)
-        c->bswap_buf = ff_bswap32_buf_rvb;
+        c->bswap32_buf = ff_bswap32_buf_rvb;
 #endif
 #if HAVE_RVV
     if (cpu_flags & AV_CPU_FLAG_RVV_I32) {
-        c->bswap_buf = ff_bswap32_buf_rvv;
+        c->bswap32_buf = ff_bswap32_buf_rvv;
         c->bswap16_buf = ff_bswap16_buf_rvv;
     }
 #endif
diff --git a/libavcodec/truemotion2.c b/libavcodec/truemotion2.c
index b168b9cda1..772504d65b 100644
--- a/libavcodec/truemotion2.c
+++ b/libavcodec/truemotion2.c
@@ -907,8 +907,8 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *rframe,
     if ((ret = ff_reget_buffer(avctx, p, 0)) < 0)
         return ret;
 
-    l->bdsp.bswap_buf((uint32_t *) l->buffer, (const uint32_t *) buf,
-                      buf_size >> 2);
+    l->bdsp.bswap32_buf((uint32_t *) l->buffer, (const uint32_t *) buf,
+                        buf_size >> 2);
 
     if ((ret = tm2_read_header(l, l->buffer)) < 0) {
         return ret;
diff --git a/libavcodec/truespeech.c b/libavcodec/truespeech.c
index 454121cc75..5689db675c 100644
--- a/libavcodec/truespeech.c
+++ b/libavcodec/truespeech.c
@@ -82,7 +82,7 @@ static void truespeech_read_frame(TSContext *dec, const uint8_t *input)
 {
     GetBitContext gb;
 
-    dec->bdsp.bswap_buf((uint32_t *) dec->buffer, (const uint32_t *) input, 8);
+    dec->bdsp.bswap32_buf((uint32_t *) dec->buffer, (const uint32_t *) input, 8);
     init_get_bits(&gb, dec->buffer, 32 * 8);
 
     dec->vector[7] = ts_codebook[7][get_bits(&gb, 3)];
diff --git a/libavcodec/utvideodec.c b/libavcodec/utvideodec.c
index 83120d1b22..7b943faed8 100644
--- a/libavcodec/utvideodec.c
+++ b/libavcodec/utvideodec.c
@@ -150,9 +150,9 @@ static int decode_plane10(UtvideoContext *c, int plane_no,
         }
 
         memset(c->slice_bits + slice_size, 0, AV_INPUT_BUFFER_PADDING_SIZE);
-        c->bdsp.bswap_buf((uint32_t *) c->slice_bits,
-                          (uint32_t *)(src + slice_data_start + c->slices * 4),
-                          (slice_data_end - slice_data_start + 3) >> 2);
+        c->bdsp.bswap32_buf((uint32_t *) c->slice_bits,
+                            (uint32_t *)(src + slice_data_start + c->slices * 4),
+                            (slice_data_end - slice_data_start + 3) >> 2);
         init_get_bits(&gb, c->slice_bits, slice_size * 8);
 
         prev = 0x200;
@@ -311,9 +311,9 @@ static int decode_plane(UtvideoContext *c, int plane_no,
         }
 
         memset(c->slice_bits + slice_size, 0, AV_INPUT_BUFFER_PADDING_SIZE);
-        c->bdsp.bswap_buf((uint32_t *) c->slice_bits,
-                          (uint32_t *)(src + slice_data_start + c->slices * 4),
-                          (slice_data_end - slice_data_start + 3) >> 2);
+        c->bdsp.bswap32_buf((uint32_t *) c->slice_bits,
+                            (uint32_t *)(src + slice_data_start + c->slices * 4),
+                            (slice_data_end - slice_data_start + 3) >> 2);
         init_get_bits(&gb, c->slice_bits, slice_size * 8);
 
         prev = 0x80;
diff --git a/libavcodec/utvideoenc.c b/libavcodec/utvideoenc.c
index d4388da8ba..0cfec16ec3 100644
--- a/libavcodec/utvideoenc.c
+++ b/libavcodec/utvideoenc.c
@@ -490,9 +490,9 @@ static int encode_plane(AVCodecContext *avctx, const uint8_t *src,
         slice_len = offset - slice_len;
 
         /* Byteswap the written huffman codes */
-        c->bdsp.bswap_buf((uint32_t *) c->slice_bits,
-                          (uint32_t *) c->slice_bits,
-                          slice_len >> 2);
+        c->bdsp.bswap32_buf((uint32_t *) c->slice_bits,
+                            (uint32_t *) c->slice_bits,
+                            slice_len >> 2);
 
         /* Write the offset to the stream */
         bytestream2_put_le32(pb, offset);
diff --git a/libavcodec/x86/bswapdsp.asm b/libavcodec/x86/bswapdsp.asm
index 2aa235e13c..4e6918ea5a 100644
--- a/libavcodec/x86/bswapdsp.asm
+++ b/libavcodec/x86/bswapdsp.asm
@@ -97,7 +97,7 @@ SECTION .text
     add      r0, 16
 %endmacro
 
-; void ff_bswap_buf(uint32_t *dst, const uint32_t *src, int w);
+; void ff_.bswap32_buf(uint32_t *dst, const uint32_t *src, int w);
 %macro BSWAP32_BUF 0
 %if cpuflag(ssse3)||cpuflag(avx2)
 cglobal bswap32_buf, 3,4,3
diff --git a/libavcodec/x86/bswapdsp_init.c b/libavcodec/x86/bswapdsp_init.c
index 877bab1a2c..b00a3efd2f 100644
--- a/libavcodec/x86/bswapdsp_init.c
+++ b/libavcodec/x86/bswapdsp_init.c
@@ -32,9 +32,9 @@ av_cold void ff_bswapdsp_init_x86(BswapDSPContext *c)
     int cpu_flags = av_get_cpu_flags();
 
     if (EXTERNAL_SSE2(cpu_flags))
-        c->bswap_buf = ff_bswap32_buf_sse2;
+        c->bswap32_buf = ff_bswap32_buf_sse2;
     if (EXTERNAL_SSSE3(cpu_flags))
-        c->bswap_buf = ff_bswap32_buf_ssse3;
+        c->bswap32_buf = ff_bswap32_buf_ssse3;
     if (EXTERNAL_AVX2_FAST(cpu_flags))
-        c->bswap_buf = ff_bswap32_buf_avx2;
+        c->bswap32_buf = ff_bswap32_buf_avx2;
 }
diff --git a/libavcodec/ylc.c b/libavcodec/ylc.c
index 29c10f05da..8eace8c2e2 100644
--- a/libavcodec/ylc.c
+++ b/libavcodec/ylc.c
@@ -311,9 +311,9 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *p,
 
     memcpy(s->buffer, avpkt->data + toffset, boffset - toffset);
     memset(s->buffer + boffset - toffset, 0, AV_INPUT_BUFFER_PADDING_SIZE);
-    s->bdsp.bswap_buf((uint32_t *) s->buffer,
-                      (uint32_t *) s->buffer,
-                      (boffset - toffset + 3) >> 2);
+    s->bdsp.bswap32_buf((uint32_t *) s->buffer,
+                        (uint32_t *) s->buffer,
+                        (boffset - toffset + 3) >> 2);
     if ((ret = init_get_bits8(&gb, s->buffer, boffset - toffset)) < 0)
         return ret;
 
@@ -332,9 +332,9 @@ static int decode_frame(AVCodecContext *avctx, AVFrame *p,
 
     memcpy(s->buffer, avpkt->data + boffset, avpkt->size - boffset);
     memset(s->buffer + avpkt->size - boffset, 0, AV_INPUT_BUFFER_PADDING_SIZE);
-    s->bdsp.bswap_buf((uint32_t *) s->buffer,
-                      (uint32_t *) s->buffer,
-                      (avpkt->size - boffset) >> 2);
+    s->bdsp.bswap32_buf((uint32_t *) s->buffer,
+                        (uint32_t *) s->buffer,
+                        (avpkt->size - boffset) >> 2);
     if ((ret = init_get_bits8(&gb, s->buffer, avpkt->size - boffset)) < 0)
         return ret;
 
diff --git a/tests/checkasm/bswapdsp.c b/tests/checkasm/bswapdsp.c
index d789e90de3..8ac6b54ae2 100644
--- a/tests/checkasm/bswapdsp.c
+++ b/tests/checkasm/bswapdsp.c
@@ -67,7 +67,7 @@ void checkasm_check_bswapdsp(void)
 
     ff_bswapdsp_init(&h);
 
-    if (check_func(h.bswap_buf, "bswap_buf"))
+    if (check_func(h.bswap32_buf, "bswap32_buf"))
         check_bswap(uint32_t);
 
     if (check_func(h.bswap16_buf, "bswap16_buf"))